/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.EsquemaCorridaDAO;
import com.rjconsultores.ventaboletos.dao.RolOperativoDAO;
import com.rjconsultores.ventaboletos.entidad.DiagramaAutobus;
import com.rjconsultores.ventaboletos.entidad.RolOperativo;
import com.rjconsultores.ventaboletos.service.RolOperativoService;
import com.rjconsultores.ventaboletos.utilerias.RegistroConDependenciaException;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

/**
 * 
 * @author Rafius
 */
@Service("rolOperativoService")
public class RolOperativoServiceImpl implements RolOperativoService {

	@Autowired
	private RolOperativoDAO rolOperativoDAO;
	@Autowired
	private EsquemaCorridaDAO esquemaCorridaDAO;

	public List<RolOperativo> obtenerTodos() {
		return rolOperativoDAO.obtenerTodos();
	}

	public RolOperativo obtenerID(Integer id) {
		return rolOperativoDAO.obtenerID(id);
	}

	@Transactional
	public RolOperativo suscribir(RolOperativo entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return rolOperativoDAO.suscribir(entidad);
	}

	@Transactional
	public RolOperativo actualizacion(RolOperativo entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return rolOperativoDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(RolOperativo entidad) throws RegistroConDependenciaException {
		if (esquemaCorridaDAO.count("rolOperativo", entidad) > 0l) {
			throw new RegistroConDependenciaException();
		}
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		rolOperativoDAO.actualizacion(entidad);
	}

	public List<RolOperativo> pesquisar(DiagramaAutobus diagrama, String rol) {

		return rolOperativoDAO.pesquisar(diagrama, rol);
	}

	public List<RolOperativo> buscar(String descroloperativo) {
		return rolOperativoDAO.buscar(descroloperativo);
	}

}
